<?php
/**
 * Admin functions
**/
add_action('admin_menu', 'egoi_mail_list_builder_woocommerce_auth',1);
add_action('admin_menu', 'egoi_mail_list_builder_woocommerce_login_logout',3);
add_action('admin_menu', 'egoi_mail_list_builder_woocommerce_admin_menu_setup',5);

/**
 * Register menu items
**/
function egoi_mail_list_builder_woocommerce_admin_menu_setup() {
	$page_title = 'E-goi Mail List Builder Woo Commerce';
	$menu_title = 'E-goi Mail List Builder Woo Commerce';
	$capability = 'manage_options';
	$menu_slug = 'egoi-mail-list-builder-woocommerce-info';
	$function = 'egoi_mail_list_builder_woocommerce_info';
	add_menu_page($page_title, $menu_title, $capability, $menu_slug, $function);
	
	$EgoiMailListBuilderWooCommerce = get_option('EgoiMailListBuilderWooCommerceObject');
	if($EgoiMailListBuilderWooCommerce->isAuthed() && in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) )) {
		$page_title = 'Info';
		$sub_menu_title = 'Info';
		add_submenu_page($menu_slug, $page_title, $sub_menu_title, $capability, $menu_slug, $function);
		
		$submenu_page_title = 'Lists';
		$submenu_title = 'Lists';
		$submenu_slug = 'egoi-mail-list-builder-woocommerce-lists';
		$submenu_function = 'egoi_mail_list_builder_woocommerce_lists';
		add_submenu_page($menu_slug, $submenu_page_title, $submenu_title, $capability, $submenu_slug, $submenu_function);

		$submenu_page_title = 'Settings';
		$submenu_title = 'Settings';
		$submenu_slug = 'egoi-mail-list-builder-woocommerce-settings';
		$submenu_function = 'egoi_mail_list_builder_woocommerce_settings';
		add_submenu_page($menu_slug, $submenu_page_title, $submenu_title, $capability, $submenu_slug, $submenu_function);

		$submenu_page_title = 'Widget Settings';
		$submenu_title = 'Widget Settings';
		$submenu_slug = 'egoi-mail-list-builder-woocommerce-widget-settings';
		$submenu_function = 'egoi_mail_list_builder_woocommerce_widget_settings';
		add_submenu_page($menu_slug, $submenu_page_title, $submenu_title, $capability, $submenu_slug, $submenu_function);

		$submenu_page_title = 'Widget Style';
		$submenu_title = 'Widget Style';
		$submenu_slug = 'egoi-mail-list-builder-woocommerce-widget-style';
		$submenu_function = 'egoi_mail_list_builder_woocommerce_widget_style';
		add_submenu_page($menu_slug, $submenu_page_title, $submenu_title, $capability, $submenu_slug, $submenu_function);

		$submenu_page_title = 'Import';
		$submenu_title = 'Import';
		$submenu_slug = 'egoi-mail-list-builder-woocommerce-import';
		$submenu_function = 'egoi_mail_list_builder_woocommerce_import';
		add_submenu_page($menu_slug, $submenu_page_title, $submenu_title, $capability, $submenu_slug, $submenu_function);
	}
}
 
function egoi_mail_list_builder_woocommerce_info() {
    if (!current_user_can('manage_options')) {
        wp_die('You do not have sufficient permissions to access this page.');
    }
	else {
		require(EGOI_MAIL_LIST_BUILDER_WOOCOMMERCE_DIR.'includes/info.php');
	}
}

function egoi_mail_list_builder_woocommerce_lists() {
    if (!current_user_can('manage_options')) {
        wp_die('You do not have sufficient permissions to access this page.');
    }
	else {
		require(EGOI_MAIL_LIST_BUILDER_WOOCOMMERCE_DIR.'includes/lists.php');
	}
}

function egoi_mail_list_builder_woocommerce_settings() {
    if (!current_user_can('manage_options')) {
        wp_die('You do not have sufficient permissions to access this page.');
    }
	else {
		require(EGOI_MAIL_LIST_BUILDER_WOOCOMMERCE_DIR.'includes/settings.php');
	}
}

function egoi_mail_list_builder_woocommerce_widget_settings() {
    if (!current_user_can('manage_options')) {
        wp_die('You do not have sufficient permissions to access this page.');
    }
	else {
		require(EGOI_MAIL_LIST_BUILDER_WOOCOMMERCE_DIR.'includes/widget_settings.php');
	}
}

function egoi_mail_list_builder_woocommerce_widget_style() {
	if (!current_user_can('manage_options')) {
		wp_die('You do not have sufficient permissions to access this page.');
	}
	else {
		require(EGOI_MAIL_LIST_BUILDER_WOOCOMMERCE_DIR.'includes/widget_style.php');
	}
}

function egoi_mail_list_builder_woocommerce_import() {
    if (!current_user_can('manage_options')) {
        wp_die('You do not have sufficient permissions to access this page.');
    }
	else {
		require(EGOI_MAIL_LIST_BUILDER_WOOCOMMERCE_DIR.'includes/import.php');
	}
}

/**
 * Add Egoi Mail List Builder Class to Options
**/
function egoi_mail_list_builder_woocommerce_auth() {
	if(!get_option('EgoiMailListBuilderWooCommerceObject')) {
		$EgoiMailListBuilderWooCommerce = new EgoiMailListBuilderWooCommerce('');
		add_option('EgoiMailListBuilderWooCommerceObject',$EgoiMailListBuilderWooCommerce);
	}
}

/**
 * Check if user is logging in
**/
function egoi_mail_list_builder_woocommerce_login_logout() {
	if(isset($_POST['egoi_mail_list_builder_woocommerce_logout']))	{
		$EgoiMailListBuilderWooCommerce = get_option('EgoiMailListBuilderWooCommerceObject');
		$EgoiMailListBuilderWooCommerce = new EgoiMailListBuilderWooCommerce('',true);
		update_option('EgoiMailListBuilderWooCommerceObject',$EgoiMailListBuilderWooCommerce);
	}
	else if(isset($_POST['egoi_mail_list_builder_woocommerce_login']))	{
		$EgoiMailListBuilderWooCommerce = get_option('EgoiMailListBuilderWooCommerceObject');
		if(isset($_POST['egoi_mail_list_builder_woocommerce_apikey_text'])) {
			if(!empty($_POST['egoi_mail_list_builder_woocommerce_apikey_text'])){
				$EgoiMailListBuilderWooCommerce = new EgoiMailListBuilderWooCommerce($_POST['egoi_mail_list_builder_woocommerce_apikey_text']);	
			}
			else{
				$EgoiMailListBuilderWooCommerce->exists = true;
		    	$EgoiMailListBuilderWooCommerce->description = "Please fill in an API key.";
		    	$EgoiMailListBuilderWooCommerce->error = "NOAPIKEY";
			}
		}
		update_option('EgoiMailListBuilderWooCommerceObject',$EgoiMailListBuilderWooCommerce);
	}
}

function egoi_mail_list_builder_woocommerce_admin_notices() {
	if(get_option('EgoiMailListBuilderWooCommerceObject')) {
		$EgoiMailListBuilderWooCommerce = get_option('EgoiMailListBuilderWooCommerceObject');
	 	$screen_id = get_current_screen()->id;
	 	if ((
	 		$screen_id == 'toplevel_page_egoi-mail-list-builder-woocommerce-info' || 
	 		$screen_id == 'e-goi-mail-list-builder_page_egoi-mail-list-builder-woocommerce-lists' ||
	 		$screen_id == 'e-goi-mail-list-builder_page_egoi-mail-list-builder-woocommerce-settings' ||
			$screen_id == 'e-goi-mail-list-builder_page_egoi-mail-list-builder-woocommerce-widget-style' ||
			$screen_id == 'e-goi-mail-list-builder_page_egoi-mail-list-builder-woocommerce-import' ||
	 		$screen_id == 'e-goi-mail-list-builder_page_egoi-mail-list-builder-woocommerce-widget-settings'
	 		) 
	 		&& $EgoiMailListBuilderWooCommerce->exists) {
	 		if($EgoiMailListBuilderWooCommerce->error == "NO_USERNAME_AND_PASSWORD_AND_APIKEY"){
	 			printf('<div class="updated"><p>'.$EgoiMailListBuilderWooCommerce->description.'</p></div>');
	 		}
	 		else{
	    		printf('<div class="error"><p>'.$EgoiMailListBuilderWooCommerce->description.'</p></div>');
	    	}
	    	$EgoiMailListBuilderWooCommerce->exists = false;
	    	$EgoiMailListBuilderWooCommerce->description = "";
	    	$EgoiMailListBuilderWooCommerce->error = "";
	    	update_option('EgoiMailListBuilderWooCommerceObject',$EgoiMailListBuilderWooCommerce);
	 	}
 	}
 	// Notice about new update!!
 	/*if ((
	 		$screen_id == 'toplevel_page_egoi-mail-list-builder-woocommerce-info' || 
	 		$screen_id == 'e-goi-mail-list-builder_page_egoi-mail-list-builder-woocommerce-lists' ||
	 		$screen_id == 'e-goi-mail-list-builder_page_egoi-mail-list-builder-woocommerce-settings' ||
	 		$screen_id == 'e-goi-mail-list-builder_page_egoi-mail-list-builder-woocommerce-widget-settings'
	 		) && egoi_mail_list_builder_woocommerce_check_update_version()) {
    	printf( '<div class="updated"> 
    		<p> A <strong>new version</strong> has been released! Click <strong><a href="'.egoi_mail_list_builder_woocommerce_download_update_version().'">here</a></strong> to update!<br /> Feel free to support the development of this plugin! (hint: you can buy us a beer!) </p> </div>');
 	}*/

}
add_action( 'admin_notices', 'egoi_mail_list_builder_woocommerce_admin_notices' );

 
function egoi_mail_list_builder_woocommerce_check_update_version(){
	$payload = array(
	  'action' => 'plugin_information',
	  'request' => serialize(
	    (object)array(
	        'slug' => 'egoi-mail-list-builder-woocommerce',
	        'fields' => array('description' => true)
	     )
	   )
	);
	$body = wp_remote_post( 'http://api.wordpress.org/plugins/info/1.0/', array( 'body' => $payload) );
	if (version_compare(EGOI_MAIL_LIST_BUILDER_WOOCOMMERCE_VERSION, unserialize($body['body'])->version, '<')) {
        return true;
    }
	return false;
}

function egoi_mail_list_builder_woocommerce_download_update_version(){
	$payload = array(
	  'action' => 'plugin_information',
	  'request' => serialize(
	    (object)array(
	        'slug' => 'egoi-mail-list-builder-woocommerce',
	        'fields' => array('description' => true)
	     )
	   )
	);
	$body = wp_remote_post( 'http://api.wordpress.org/plugins/info/1.0/', array( 'body' => $payload) );
	return unserialize($body['body'])->download_link;
}
?>