<?php
/**
 * Egoi Mail List Builder main class
**/


class EgoiMailListBuilderWooCommerce {
	private $egoiMailListBuilderWooCommerceData = array(
		'api_key' => '',
		'client_id' => ''
	);
	
	private $egoiMailListBuilderWooCommerceError = array(
		"exists" => false,
		"error" => "",
		"description" => "",
	);

	private $egoiMailListBuilderWooCommerceComments = array(
		"subscribe_enable" => false,
		"hide_subscribe" => false,
		"subscribe_enable_checkout" => false,
		"subscribe_enable_myaccount" => false,
		"subscribe_text" => "Subscribe!",
		"subscribe_list" => ""
	);

	private $egoiMailListBuilderWooCommerceOptIn = array(
		'double_opt_in' => 0
	);

	private $egoiMailListBuilderWooCommerceErrorCodes = array();

	private $egoiMailListBuilderWooCommerceWidgetText = array();

	function __construct($api_key = '', $logout = false) {
		require(EGOI_MAIL_LIST_BUILDER_WOOCOMMERCE_DIR.'includes/error_codes.php');
		$this->egoiMailListBuilderWooCommerceErrorCodes = $errorCodes;

		require(EGOI_MAIL_LIST_BUILDER_WOOCOMMERCE_DIR.'includes/widget_text.php');
		$this->egoiMailListBuilderWooCommerceWidgetText = $widgetText;

		if(!empty($api_key)) {
			$params = array(
				'apikey' => $api_key, 
				'plugin_key' => EGOI_MAIL_LIST_BUILDER_WOOCOMMERCE_PLUGIN_KEY);
			$result = $this->connectXmlrpc('getClientData',$params);
			if(is_string($result)){
				if(array_key_exists((string)$result,$this->egoiMailListBuilderWooCommerceErrorCodes)) {
						$this->egoiMailListBuilderWooCommerceError['exists'] = true;
						$this->egoiMailListBuilderWooCommerceError['error'] = (string)$result;
						$this->egoiMailListBuilderWooCommerceError['description'] = $this->egoiMailListBuilderWooCommerceErrorCodes[(string)$result];
				}
			}
			else {
				$this->egoiMailListBuilderWooCommerceData['api_key'] = $api_key;
				$this->egoiMailListBuilderWooCommerceData['client_id'] = $result['CLIENTE_ID'];
			}
		}
		else {
			if(!$logout){
				$params = array(
					'apikey' => $this->egoiMailListBuilderWooCommerceData['api_key'], 
					'plugin_key' => EGOI_MAIL_LIST_BUILDER_WOOCOMMERCE_PLUGIN_KEY);
				$result = $this->connectXmlrpc('getClientData',$params);
				if(is_string($result)){
					if(array_key_exists((string)$result,$this->egoiMailListBuilderWooCommerceErrorCodes)) {
							$this->egoiMailListBuilderWooCommerceError['exists'] = true;
							$this->egoiMailListBuilderWooCommerceError['error'] = (string)$result;
							$this->egoiMailListBuilderWooCommerceError['description'] = $this->egoiMailListBuilderWooCommerceErrorCodes[(string)$result];
					}
				}
				else {
					$this->egoiMailListBuilderWooCommerceData['client_id'] = $result['CLIENTE_ID'];
				}
			}
		}
	}
	
	private function connectXmlrpc($callType, $params) {
		$client = new Zend_XmlRpc_Client(EGOI_MAIL_LIST_BUILDER_WOOCOMMERCE_XMLRPC_URL);
		$client->getHttpClient()->setConfig(array('timeout'=>60));

		$result = $client->call($callType, array($params));
		return $result;
	}
	
	public function __get($egoiMailListBuilderWooCommerceName) {
        if (array_key_exists($egoiMailListBuilderWooCommerceName, $this->egoiMailListBuilderWooCommerceData)) {
            return $this->egoiMailListBuilderWooCommerceData[$egoiMailListBuilderWooCommerceName];
        }
        else if (array_key_exists($egoiMailListBuilderWooCommerceName, $this->egoiMailListBuilderWooCommerceError)) {
            return $this->egoiMailListBuilderWooCommerceError[$egoiMailListBuilderWooCommerceName];
        }
        else if (array_key_exists($egoiMailListBuilderWooCommerceName, $this->egoiMailListBuilderWooCommerceWidgetText)) {
            return $this->egoiMailListBuilderWooCommerceWidgetText[$egoiMailListBuilderWooCommerceName];
        }
        else if (array_key_exists($egoiMailListBuilderWooCommerceName, $this->egoiMailListBuilderWooCommerceComments)) {
            return $this->egoiMailListBuilderWooCommerceComments[$egoiMailListBuilderWooCommerceName];
        }
        else if (array_key_exists($egoiMailListBuilderWooCommerceName, $this->egoiMailListBuilderWooCommerceOptIn)) {
            return $this->egoiMailListBuilderWooCommerceOptIn[$egoiMailListBuilderWooCommerceName];
        }
		else {
			return null;
		}
	}
	
	public function __set($egoiMailListBuilderWooCommerceName, $egoiMailListBuilderWooCommerceValue) {
		if (array_key_exists($egoiMailListBuilderWooCommerceName, $this->egoiMailListBuilderWooCommerceData)) {
        	$this->egoiMailListBuilderWooCommerceData[$egoiMailListBuilderWooCommerceName] = $egoiMailListBuilderWooCommerceValue;
    	}
    	else if (array_key_exists($egoiMailListBuilderWooCommerceName, $this->egoiMailListBuilderWooCommerceError)) {
            $this->egoiMailListBuilderWooCommerceError[$egoiMailListBuilderWooCommerceName] = $egoiMailListBuilderWooCommerceValue;
        }
        else if (array_key_exists($egoiMailListBuilderWooCommerceName, $this->egoiMailListBuilderWooCommerceWidgetText)) {
            $this->egoiMailListBuilderWooCommerceWidgetText[$egoiMailListBuilderWooCommerceName] = $egoiMailListBuilderWooCommerceValue;
        }
        else if (array_key_exists($egoiMailListBuilderWooCommerceName, $this->egoiMailListBuilderWooCommerceComments)) {
            $this->egoiMailListBuilderWooCommerceComments[$egoiMailListBuilderWooCommerceName] = $egoiMailListBuilderWooCommerceValue;
        }
        else if (array_key_exists($egoiMailListBuilderWooCommerceName, $this->egoiMailListBuilderWooCommerceOptIn)) {
            $this->egoiMailListBuilderWooCommerceOptIn[$egoiMailListBuilderWooCommerceName] = $egoiMailListBuilderWooCommerceValue;
        }
		else {
			return null;
		}
    }
	
	public function isAuthed() {
		if(
			!empty($this->egoiMailListBuilderWooCommerceData['client_id']) && 
			isset($this->egoiMailListBuilderWooCommerceData['client_id']) && 
			!empty($this->egoiMailListBuilderWooCommerceData['api_key']))
		{
			return true;
		}
		else
		{
			return false;
		}
	}
	
	public function getClient() {
		$params = array(
			'plugin_key' => EGOI_MAIL_LIST_BUILDER_WOOCOMMERCE_PLUGIN_KEY,
			'apikey' => $this->egoiMailListBuilderWooCommerceData['api_key']
		);
		$result = $this->connectXmlrpc('getClientData',$params);
		if(is_string($result)){
			if(array_key_exists((string)$result,$this->egoiMailListBuilderWooCommerceErrorCodes)) {
					$this->egoiMailListBuilderWooCommerceError['exists'] = true;
					$this->egoiMailListBuilderWooCommerceError['error'] = (string)$result;
					$this->egoiMailListBuilderWooCommerceError['description'] = $this->egoiMailListBuilderWooCommerceErrorCodes[(string)$result];
			}
		}
		else {
			return $result;
		}
	}
	
	public function getLists() {
		$params = array(
			'plugin_key' => EGOI_MAIL_LIST_BUILDER_WOOCOMMERCE_PLUGIN_KEY,
			'apikey' => $this->egoiMailListBuilderWooCommerceData['api_key']
		);
		$result = $this->connectXmlrpc('getLists',$params);
		if(is_string($result)){
			if(array_key_exists((string)$result,$this->egoiMailListBuilderWooCommerceErrorCodes)) {
				$this->egoiMailListBuilderWooCommerceError['exists'] = true;
				$this->egoiMailListBuilderWooCommerceError['error'] = (string)$result;
				$this->egoiMailListBuilderWooCommerceError['description'] = $this->egoiMailListBuilderWooCommerceErrorCodes[(string)$result];
			}
		}
		else if(is_array($result)){
			if(isset($result["ERROR"])){
				if(array_key_exists((string)$result["ERROR"],$this->egoiMailListBuilderWooCommerceErrorCodes)) {
					$this->egoiMailListBuilderWooCommerceError['exists'] = true;
					$this->egoiMailListBuilderWooCommerceError['error'] = (string)$result["ERROR"];
					$this->egoiMailListBuilderWooCommerceError['description'] = $this->egoiMailListBuilderWooCommerceErrorCodes[(string)$result["ERROR"]];
				}
			}
			else {
				return $result;
			}
		}
	}
	
	public function createList($nome = '', $idioma_lista = '') {
		$params = array(
			'plugin_key' => EGOI_MAIL_LIST_BUILDER_WOOCOMMERCE_PLUGIN_KEY,
			'apikey' => $this->egoiMailListBuilderWooCommerceData['api_key'],
			'nome' => $nome,
			'idioma_lista' => $idioma_lista,
			'canal_email' => '1',
			'canal_sms' => '0',
			'canal_fax' => '0',
			'canal_voz' => '0',
			'canal_mms' => '0'
		);
		$result = $this->connectXmlrpc('createList',$params);

		if(is_string($result)){
			if(array_key_exists((string)$result,$this->egoiMailListBuilderWooCommerceErrorCodes)) {
					$this->egoiMailListBuilderWooCommerceError['exists'] = true;
					$this->egoiMailListBuilderWooCommerceError['error'] = (string)$result;
					$this->egoiMailListBuilderWooCommerceError['description'] = $this->egoiMailListBuilderWooCommerceErrorCodes[(string)$result];
			}
		}
		if(is_array($result)){
			if(isset($result["ERROR"])){
				if(array_key_exists((string)$result["ERROR"],$this->egoiMailListBuilderWooCommerceErrorCodes)) {
						$this->egoiMailListBuilderWooCommerceError['exists'] = true;
						$this->egoiMailListBuilderWooCommerceError['error'] = (string)$result["ERROR"];
						$this->egoiMailListBuilderWooCommerceError['description'] = $this->egoiMailListBuilderWooCommerceErrorCodes[(string)$result["ERROR"]];
				}
			}
		}
	}
	
	public function updateList($listID = '',$name = '', $idioma_lista = '') {
		$params = array(
			'plugin_key' => EGOI_MAIL_LIST_BUILDER_WOOCOMMERCE_PLUGIN_KEY,
			'apikey' => $this->egoiMailListBuilderWooCommerceData['api_key'],
			'listID' => $listID,
			'name' => $name,
			'language' => $idioma_lista
		);
		//$params = php_xmlrpc_encode($params);
		$result = $this->connectXmlrpc('updateList',$params);
		if(is_string($result)){
			if(isset($result["ERROR"])){
				if(array_key_exists((string)$result,$this->egoiMailListBuilderWooCommerceErrorCodes)) {
						$this->egoiMailListBuilderWooCommerceError['exists'] = true;
						$this->egoiMailListBuilderWooCommerceError['error'] = (string)$result;
						$this->egoiMailListBuilderWooCommerceError['description'] = $this->egoiMailListBuilderWooCommerceErrorCodes[(string)$result];
				}
			}
		}
	}
	
	public function addSubscriber($listID = '', $first_name = '', $last_name = '', $email = '', $cellphone = '', $lang = '', $birth_date = '') {
		$params = array(
			'plugin_key' => EGOI_MAIL_LIST_BUILDER_WOOCOMMERCE_PLUGIN_KEY,
			'apikey' => $this->egoiMailListBuilderWooCommerceData['api_key'],
			'status' => $this->egoiMailListBuilderWooCommerceOptIn['double_opt_in'],
			'listID' => $listID,
			'first_name' => $first_name,
			'last_name' => $last_name,
			'email' => $email,
			'cellphone' => $cellphone,
			'lang' => $lang,
			'birth_date' => $birth_date
		);

		$result = $this->connectXmlrpc('addSubscriber',$params);
		
		if(is_string($result)){
			if(array_key_exists((string)$result,$this->egoiMailListBuilderWooCommerceErrorCodes)) {
				/*$this->egoiMailListBuilderWooCommerceError['exists'] = true;
				$this->egoiMailListBuilderWooCommerceError['error'] = (string)$result;
				$this->egoiMailListBuilderWooCommerceError['description'] = $this->egoiMailListBuilderWooCommerceErrorCodes[(string)$result];*/
				return $this->egoiMailListBuilderWooCommerceErrorCodes[(string)$result];
			}
		}
		if(is_array($result)){
			if(isset($result["ERROR"])){
				if(array_key_exists((string)$result["ERROR"],$this->egoiMailListBuilderWooCommerceErrorCodes)) {
					/*$this->egoiMailListBuilderWooCommerceError['exists'] = true;
					$this->egoiMailListBuilderWooCommerceError['error'] = (string)$result["ERROR"];
					$this->egoiMailListBuilderWooCommerceError['description'] = $this->egoiMailListBuilderWooCommerceErrorCodes[(string)$result["ERROR"]];*/
					return $this->egoiMailListBuilderWooCommerceErrorCodes[(string)$result["ERROR"]];
				}
			}
		}
		
	}

	public function checkSubscriber($listID, $subscriber){
		$params = array(
			'plugin_key' => EGOI_MAIL_LIST_BUILDER_WOOCOMMERCE_PLUGIN_KEY,
			'apikey' => $this->egoiMailListBuilderWooCommerceData['api_key'],
			'listID' => $listID,
			'subscriber' => $subscriber
		);
		$result = $this->connectXmlrpc('subscriberData',$params);
		if(is_array($result)){
			if(isset($result['ERROR'])){
				if(array_key_exists($result['ERROR'],$this->egoiMailListBuilderWooCommerceErrorCodes)) {
					return -1;
				}
			}
			else{
				return $result['subscriber']['STATUS'];
			}
		}
	}
}
?>